
_INTERRUPT_UART2_RX:
	LNK	#2
	PUSH	RCOUNT
	PUSH	W0
	MOV	#2, W0
	REPEAT	#12
	PUSH	[W0++]

;Testbed.c,29 :: 		void INTERRUPT_UART2_RX() iv IVT_ADDR_U2RXINTERRUPT {
;Testbed.c,31 :: 		while (Uart2_Data_Ready()) {
L_INTERRUPT_UART2_RX0:
	CALL	_UART2_Data_Ready
	CP0	W0
	BRA NZ	L__INTERRUPT_UART2_RX20
	GOTO	L_INTERRUPT_UART2_RX1
L__INTERRUPT_UART2_RX20:
;Testbed.c,32 :: 		txt[i] = Uart2_Read();
	MOV	#lo_addr(_txt), W1
	MOV	#lo_addr(_i), W0
	ADD	W1, [W0], W0
	MOV	W0, [W14+0]
	CALL	_UART2_Read
	MOV	[W14+0], W1
	MOV.B	W0, [W1]
;Testbed.c,33 :: 		i++;
	MOV	#1, W1
	MOV	#lo_addr(_i), W0
	ADD	W1, [W0], [W0]
;Testbed.c,34 :: 		}
	GOTO	L_INTERRUPT_UART2_RX0
L_INTERRUPT_UART2_RX1:
;Testbed.c,36 :: 		if (i>500){
	MOV	_i, W1
	MOV	#500, W0
	CP	W1, W0
	BRA GT	L__INTERRUPT_UART2_RX21
	GOTO	L_INTERRUPT_UART2_RX2
L__INTERRUPT_UART2_RX21:
;Testbed.c,37 :: 		ready=1;                                                                       //set data as available
	MOV	#1, W0
	MOV	W0, _ready
;Testbed.c,38 :: 		U2RXIE_bit=0;
	BCLR	U2RXIE_bit, #14
;Testbed.c,39 :: 		}
L_INTERRUPT_UART2_RX2:
;Testbed.c,41 :: 		U2STA.OERR= 0;                                                                 //set OERR status bit to 0
	BCLR	U2STA, #1
;Testbed.c,42 :: 		U2STA.FERR= 0;                                                                 //set FERRR status bit to 0
	BCLR	U2STA, #2
;Testbed.c,43 :: 		U2RXIF_bit=0;                                                                  //Clear Receive Interrupt Flag
	BCLR	U2RXIF_bit, #14
;Testbed.c,45 :: 		}
L_end_INTERRUPT_UART2_RX:
	MOV	#26, W0
	REPEAT	#12
	POP	[W0--]
	POP	W0
	POP	RCOUNT
	ULNK
	RETFIE
; end of _INTERRUPT_UART2_RX

_main:
	MOV	#2048, W15
	MOV	#6142, W0
	MOV	WREG, 32
	MOV	#1, W0
	MOV	WREG, 52
	MOV	#4, W0
	IOR	68
	LNK	#4

;Testbed.c,47 :: 		void main() {
;Testbed.c,49 :: 		ADPCFG = 0xFFFF;                                                               // Set AN pins to Digital I/O
	PUSH	W10
	PUSH	W11
	PUSH	W12
	MOV	#65535, W0
	MOV	WREG, ADPCFG
;Testbed.c,50 :: 		ready = 0;
	CLR	W0
	MOV	W0, _ready
;Testbed.c,51 :: 		i=0;
	CLR	W0
	MOV	W0, _i
;Testbed.c,53 :: 		LCD_init();                                                                    // Initialise LCD module
	CALL	_Lcd_Init
;Testbed.c,54 :: 		Delay_ms(100);                                                                 // Wait 100ms
	MOV	#3, W8
	MOV	#2261, W7
L_main3:
	DEC	W7
	BRA NZ	L_main3
	DEC	W8
	BRA NZ	L_main3
;Testbed.c,56 :: 		U2RXIF_bit=0;
	BCLR	U2RXIF_bit, #14
;Testbed.c,58 :: 		Uart2_Init(9600);                                                              // Initialize UART module
	MOV	#9600, W10
	MOV	#0, W11
	CALL	_UART2_Init
;Testbed.c,59 :: 		Delay_ms(100);
	MOV	#3, W8
	MOV	#2261, W7
L_main5:
	DEC	W7
	BRA NZ	L_main5
	DEC	W8
	BRA NZ	L_main5
;Testbed.c,61 :: 		U2RXIE_bit=1;
	BSET	U2RXIE_bit, #14
;Testbed.c,63 :: 		while (1) {
L_main7:
;Testbed.c,65 :: 		if(ready == 1) {                                                              // if the data in txt array is ready process.
	MOV	_ready, W0
	CP	W0, #1
	BRA Z	L__main23
	GOTO	L_main9
L__main23:
;Testbed.c,67 :: 		ready = 0;                                                                   // Clear the ready flag
	CLR	W0
	MOV	W0, _ready
;Testbed.c,68 :: 		string=0x00;                                                                 // Clear the string pointer
	CLR	W0
	MOV	W0, _string
;Testbed.c,69 :: 		string = strstr(txt,gpgll);                                                  // Search for $GPGLL and assign string pointer
	MOV	#lo_addr(_gpgll), W11
	MOV	#lo_addr(_txt), W10
	CALL	_strstr
	MOV	W0, _string
;Testbed.c,71 :: 		if(string != 0) {                                                            // If txt array contains "$GPGLL"
	CP	W0, #0
	BRA NZ	L__main24
	GOTO	L_main10
L__main24:
;Testbed.c,73 :: 		if(string[7] != ',') {                                                      // If the 7th character is not a comma, data has been received (consider changing to valid signal)
	MOV	_string, W0
	ADD	W0, #7, W0
	MOV.B	[W0], W1
	MOV.B	#44, W0
	CP.B	W1, W0
	BRA NZ	L__main25
	GOTO	L_main11
L__main25:
;Testbed.c,75 :: 		memset(latitude,0x00,11);                                                  // Clear Latitude String
	MOV	#11, W12
	CLR	W11
	MOV	#lo_addr(_latitude), W10
	CALL	_memset
;Testbed.c,76 :: 		memset(longitude,0x00,12);                                                 // Clear Longitude String
	MOV	#12, W12
	CLR	W11
	MOV	#lo_addr(_longitude), W10
	CALL	_memset
;Testbed.c,77 :: 		memset(hours,0x00,3);                                                      // Clear Hours
	MOV	#3, W12
	CLR	W11
	MOV	#lo_addr(_hours), W10
	CALL	_memset
;Testbed.c,78 :: 		memset(min,0x00,3);                                                        //Clear Minutes
	MOV	#3, W12
	CLR	W11
	MOV	#lo_addr(_min), W10
	CALL	_memset
;Testbed.c,79 :: 		memset(sec,0x00,3);                                                        //Clear Second
	MOV	#3, W12
	CLR	W11
	MOV	#lo_addr(_sec), W10
	CALL	_memset
;Testbed.c,81 :: 		string = strstr(txt,gpgll);                                                //
	MOV	#lo_addr(_gpgll), W11
	MOV	#lo_addr(_txt), W10
	CALL	_strstr
	MOV	W0, _string
;Testbed.c,82 :: 		memcpy(latitude,string+7,10);                                              // Copy Longitude
	ADD	W0, #7, W0
	MOV	#10, W12
	MOV	W0, W11
	MOV	#lo_addr(_latitude), W10
	CALL	_memcpy
;Testbed.c,83 :: 		memcpy(longitude,string+20,11);                                            // Copy Latitude
	MOV	_string, W0
	ADD	W0, #20, W0
	MOV	#11, W12
	MOV	W0, W11
	MOV	#lo_addr(_longitude), W10
	CALL	_memcpy
;Testbed.c,84 :: 		memcpy(hours,string+34,2);                                                 // Copy Hours
	MOV	#34, W1
	MOV	#lo_addr(_string), W0
	ADD	W1, [W0], W0
	MOV	#2, W12
	MOV	W0, W11
	MOV	#lo_addr(_hours), W10
	CALL	_memcpy
;Testbed.c,85 :: 		memcpy(min,string+36,2);                                                   // Copy Minutes
	MOV	#36, W1
	MOV	#lo_addr(_string), W0
	ADD	W1, [W0], W0
	MOV	#2, W12
	MOV	W0, W11
	MOV	#lo_addr(_min), W10
	CALL	_memcpy
;Testbed.c,86 :: 		memcpy(sec,string+38,2);                                                   //Copy
	MOV	#38, W1
	MOV	#lo_addr(_string), W0
	ADD	W1, [W0], W0
	MOV	#2, W12
	MOV	W0, W11
	MOV	#lo_addr(_sec), W10
	CALL	_memcpy
;Testbed.c,88 :: 		lat=0;
	CLR	W0
	CLR	W1
	MOV	W0, _lat
	MOV	W1, _lat+2
;Testbed.c,89 :: 		lon=0;
	CLR	W0
	CLR	W1
	MOV	W0, _lon
	MOV	W1, _lon+2
;Testbed.c,91 :: 		lat_dec=(latitude[2]-48)*1000000+(latitude[3]-48)*100000+(latitude[5]-48)*10000+(latitude[6]-48)*1000+(latitude[7]-48)*100+(latitude[8]-48)*10+(latitude[9]-48);
	MOV	#lo_addr(_latitude+2), W0
	ZE	[W0], W1
	MOV	#48, W0
	SUB	W1, W0, W0
	ASR	W0, #15, W1
	MOV	#16960, W2
	MOV	#15, W3
	CALL	__Multiply_32x32
	MOV	W0, [W14+0]
	MOV	W1, [W14+2]
	MOV	#lo_addr(_latitude+3), W0
	ZE	[W0], W1
	MOV	#48, W0
	SUB	W1, W0, W0
	ASR	W0, #15, W1
	MOV	#34464, W2
	MOV	#1, W3
	CALL	__Multiply_32x32
	MOV	[W14+0], W2
	MOV	[W14+2], W3
	ADD	W2, W0, W4
	ADDC	W3, W1, W5
	MOV	#lo_addr(_latitude+5), W0
	ZE	[W0], W1
	MOV	#48, W0
	SUB	W1, W0, W1
	MOV	#10000, W0
	MUL.SS	W1, W0, W0
	ASR	W0, #15, W1
	ADD	W4, W0, W2
	ADDC	W5, W1, W3
	MOV	#lo_addr(_latitude+6), W0
	ZE	[W0], W1
	MOV	#48, W0
	SUB	W1, W0, W1
	MOV	#1000, W0
	MUL.SS	W1, W0, W0
	ASR	W0, #15, W1
	ADD	W2, W0, W2
	ADDC	W3, W1, W3
	MOV	#lo_addr(_latitude+7), W0
	ZE	[W0], W1
	MOV	#48, W0
	SUB	W1, W0, W1
	MOV	#100, W0
	MUL.SS	W1, W0, W0
	ASR	W0, #15, W1
	ADD	W2, W0, W2
	ADDC	W3, W1, W3
	MOV	#lo_addr(_latitude+8), W0
	ZE	[W0], W1
	MOV	#48, W0
	SUB	W1, W0, W1
	MOV	#10, W0
	MUL.SS	W1, W0, W0
	ASR	W0, #15, W1
	ADD	W2, W0, W2
	ADDC	W3, W1, W3
	MOV	#lo_addr(_latitude+9), W0
	ZE	[W0], W1
	MOV	#48, W0
	SUB	W1, W0, W0
	ASR	W0, #15, W1
	ADD	W2, W0, W0
	ADDC	W3, W1, W1
	SETM	W2
	CALL	__Long2Float
	MOV	W0, _lat_dec
	MOV	W1, _lat_dec+2
;Testbed.c,92 :: 		lon_dec=(longitude[3]-48)*1000000+(longitude[4]-48)*100000+(longitude[6]-48)*10000+(longitude[7]-48)*1000+(longitude[8]-48)*100+(longitude[9]-48)*10+(longitude[10]-48);
	MOV	#lo_addr(_longitude+3), W0
	ZE	[W0], W1
	MOV	#48, W0
	SUB	W1, W0, W0
	ASR	W0, #15, W1
	MOV	#16960, W2
	MOV	#15, W3
	CALL	__Multiply_32x32
	MOV	W0, [W14+0]
	MOV	W1, [W14+2]
	MOV	#lo_addr(_longitude+4), W0
	ZE	[W0], W1
	MOV	#48, W0
	SUB	W1, W0, W0
	ASR	W0, #15, W1
	MOV	#34464, W2
	MOV	#1, W3
	CALL	__Multiply_32x32
	MOV	[W14+0], W2
	MOV	[W14+2], W3
	ADD	W2, W0, W4
	ADDC	W3, W1, W5
	MOV	#lo_addr(_longitude+6), W0
	ZE	[W0], W1
	MOV	#48, W0
	SUB	W1, W0, W1
	MOV	#10000, W0
	MUL.SS	W1, W0, W0
	ASR	W0, #15, W1
	ADD	W4, W0, W2
	ADDC	W5, W1, W3
	MOV	#lo_addr(_longitude+7), W0
	ZE	[W0], W1
	MOV	#48, W0
	SUB	W1, W0, W1
	MOV	#1000, W0
	MUL.SS	W1, W0, W0
	ASR	W0, #15, W1
	ADD	W2, W0, W2
	ADDC	W3, W1, W3
	MOV	#lo_addr(_longitude+8), W0
	ZE	[W0], W1
	MOV	#48, W0
	SUB	W1, W0, W1
	MOV	#100, W0
	MUL.SS	W1, W0, W0
	ASR	W0, #15, W1
	ADD	W2, W0, W2
	ADDC	W3, W1, W3
	MOV	#lo_addr(_longitude+9), W0
	ZE	[W0], W1
	MOV	#48, W0
	SUB	W1, W0, W1
	MOV	#10, W0
	MUL.SS	W1, W0, W0
	ASR	W0, #15, W1
	ADD	W2, W0, W2
	ADDC	W3, W1, W3
	MOV	#lo_addr(_longitude+10), W0
	ZE	[W0], W1
	MOV	#48, W0
	SUB	W1, W0, W0
	ASR	W0, #15, W1
	ADD	W2, W0, W0
	ADDC	W3, W1, W1
	SETM	W2
	CALL	__Long2Float
	MOV	W0, _lon_dec
	MOV	W1, _lon_dec+2
;Testbed.c,93 :: 		lon_dec=lon_dec/6000;
	MOV	#32768, W2
	MOV	#17851, W3
	CALL	__Div_FP
	MOV	W0, _lon_dec
	MOV	W1, _lon_dec+2
;Testbed.c,96 :: 		lat=(latitude[0]-48)*10+(latitude[1]-48)+lat_dec/6000000;           // -48 to convert from ASCII number to regular number
	MOV	#lo_addr(_latitude), W0
	ZE	[W0], W1
	MOV	#48, W0
	SUB	W1, W0, W1
	MOV	#10, W0
	MUL.SS	W1, W0, W2
	MOV	#lo_addr(_latitude+1), W0
	ZE	[W0], W1
	MOV	#48, W0
	SUB	W1, W0, W0
	ADD	W2, W0, W0
	MOV	W0, [W14+0]
	MOV	#6912, W2
	MOV	#19127, W3
	MOV	_lat_dec, W0
	MOV	_lat_dec+2, W1
	CALL	__Div_FP
	MOV	[W14+0], W2
	MOV	W0, [W14+0]
	MOV	W1, [W14+2]
	MOV	W2, W0
	ASR	W0, #15, W1
	SETM	W2
	CALL	__Long2Float
	MOV	[W14+0], W2
	MOV	[W14+2], W3
	CALL	__AddSub_FP
	MOV	W0, _lat
	MOV	W1, _lat+2
;Testbed.c,97 :: 		lon=(longitude[0]-48)*100+(longitude[1]-48)*10+(longitude[2]-48)+lon_dec/1000;        // -48 to convert from ASCII number to regular number
	MOV	#lo_addr(_longitude), W0
	ZE	[W0], W1
	MOV	#48, W0
	SUB	W1, W0, W1
	MOV	#100, W0
	MUL.SS	W1, W0, W2
	MOV	#lo_addr(_longitude+1), W0
	ZE	[W0], W1
	MOV	#48, W0
	SUB	W1, W0, W1
	MOV	#10, W0
	MUL.SS	W1, W0, W0
	ADD	W2, W0, W2
	MOV	#lo_addr(_longitude+2), W0
	ZE	[W0], W1
	MOV	#48, W0
	SUB	W1, W0, W0
	ADD	W2, W0, W0
	MOV	W0, [W14+0]
	MOV	#0, W2
	MOV	#17530, W3
	MOV	_lon_dec, W0
	MOV	_lon_dec+2, W1
	CALL	__Div_FP
	MOV	[W14+0], W2
	MOV	W0, [W14+0]
	MOV	W1, [W14+2]
	MOV	W2, W0
	ASR	W0, #15, W1
	SETM	W2
	CALL	__Long2Float
	MOV	[W14+0], W2
	MOV	[W14+2], W3
	CALL	__AddSub_FP
	MOV	W0, _lon
	MOV	W1, _lon+2
;Testbed.c,99 :: 		if (string[18]=='S'){                                                      // South is negative
	MOV	_string, W0
	ADD	W0, #18, W0
	MOV.B	[W0], W1
	MOV.B	#83, W0
	CP.B	W1, W0
	BRA Z	L__main26
	GOTO	L_main12
L__main26:
;Testbed.c,100 :: 		lat=0-lat;
	CLR	W0
	CLR	W1
	MOV	_lat, W2
	MOV	_lat+2, W3
	CALL	__Sub_FP
	MOV	W0, _lat
	MOV	W1, _lat+2
;Testbed.c,101 :: 		}
L_main12:
;Testbed.c,103 :: 		if (string[32]=='W'){                                                      //West is negative
	MOV	#32, W1
	MOV	#lo_addr(_string), W0
	ADD	W1, [W0], W0
	MOV.B	[W0], W1
	MOV.B	#87, W0
	CP.B	W1, W0
	BRA Z	L__main27
	GOTO	L_main13
L__main27:
;Testbed.c,104 :: 		lon=0-lon;
	CLR	W0
	CLR	W1
	MOV	_lon, W2
	MOV	_lon+2, W3
	CALL	__Sub_FP
	MOV	W0, _lon
	MOV	W1, _lon+2
;Testbed.c,105 :: 		}
L_main13:
;Testbed.c,107 :: 		floattostr(lat,lat_t);
	MOV	#lo_addr(_lat_t), W12
	MOV	_lat, W10
	MOV	_lat+2, W11
	CALL	_FloatToStr
;Testbed.c,108 :: 		floattostr(lon,long_t);
	MOV	#lo_addr(_long_t), W12
	MOV	_lon, W10
	MOV	_lon+2, W11
	CALL	_FloatToStr
;Testbed.c,110 :: 		lcd_cmd(_lcd_clear);                                                       // if "$GPGLL" NMEA message have ',' sign in the 8-th
	MOV.B	#1, W10
	CALL	_Lcd_Cmd
;Testbed.c,111 :: 		lcd_cmd(_LCD_CURSOR_OFF);
	MOV.B	#12, W10
	CALL	_Lcd_Cmd
;Testbed.c,112 :: 		lcd_out(1,1,"Lat:");
	MOV	#lo_addr(?lstr1_Testbed), W12
	MOV	#1, W11
	MOV	#1, W10
	CALL	_Lcd_Out
;Testbed.c,113 :: 		lcd_out(1,6,lat_t);
	MOV	#lo_addr(_lat_t), W12
	MOV	#6, W11
	MOV	#1, W10
	CALL	_Lcd_Out
;Testbed.c,114 :: 		lcd_out(2,1,"Long:");
	MOV	#lo_addr(?lstr2_Testbed), W12
	MOV	#1, W11
	MOV	#2, W10
	CALL	_Lcd_Out
;Testbed.c,115 :: 		lcd_out(2,6,long_t);
	MOV	#lo_addr(_long_t), W12
	MOV	#6, W11
	MOV	#2, W10
	CALL	_Lcd_Out
;Testbed.c,116 :: 		delay_ms(2000);
	MOV	#41, W8
	MOV	#45239, W7
L_main14:
	DEC	W7
	BRA NZ	L_main14
	DEC	W8
	BRA NZ	L_main14
;Testbed.c,117 :: 		lcd_cmd(_lcd_clear);
	MOV.B	#1, W10
	CALL	_Lcd_Cmd
;Testbed.c,118 :: 		lcd_out(1,1,"GPS Time:");
	MOV	#lo_addr(?lstr3_Testbed), W12
	MOV	#1, W11
	MOV	#1, W10
	CALL	_Lcd_Out
;Testbed.c,119 :: 		lcd_out(2,1,hours);
	MOV	#lo_addr(_hours), W12
	MOV	#1, W11
	MOV	#2, W10
	CALL	_Lcd_Out
;Testbed.c,120 :: 		lcd_out(2,3,":");
	MOV	#lo_addr(?lstr4_Testbed), W12
	MOV	#3, W11
	MOV	#2, W10
	CALL	_Lcd_Out
;Testbed.c,121 :: 		lcd_out(2,4,min);
	MOV	#lo_addr(_min), W12
	MOV	#4, W11
	MOV	#2, W10
	CALL	_Lcd_Out
;Testbed.c,122 :: 		lcd_out(2,6,":");
	MOV	#lo_addr(?lstr5_Testbed), W12
	MOV	#6, W11
	MOV	#2, W10
	CALL	_Lcd_Out
;Testbed.c,123 :: 		lcd_out(2,7,sec);
	MOV	#lo_addr(_sec), W12
	MOV	#7, W11
	MOV	#2, W10
	CALL	_Lcd_Out
;Testbed.c,124 :: 		delay_ms(2000);
	MOV	#41, W8
	MOV	#45239, W7
L_main16:
	DEC	W7
	BRA NZ	L_main16
	DEC	W8
	BRA NZ	L_main16
;Testbed.c,125 :: 		}
L_main11:
;Testbed.c,126 :: 		}
L_main10:
;Testbed.c,127 :: 		}
L_main9:
;Testbed.c,128 :: 		if (i>700){                                                                   //If most of the NMEA data has been read, then clear the txt counter and clear the memory
	MOV	_i, W1
	MOV	#700, W0
	CP	W1, W0
	BRA GT	L__main28
	GOTO	L_main18
L__main28:
;Testbed.c,129 :: 		i=0;
	CLR	W0
	MOV	W0, _i
;Testbed.c,130 :: 		memset(txt,0x00,1023);
	MOV	#1023, W12
	CLR	W11
	MOV	#lo_addr(_txt), W10
	CALL	_memset
;Testbed.c,131 :: 		}
L_main18:
;Testbed.c,132 :: 		U2RXIE_bit=1;                                                                 //Enable UART 2 Receive Interrupt
	BSET	U2RXIE_bit, #14
;Testbed.c,133 :: 		}
	GOTO	L_main7
;Testbed.c,134 :: 		}
L_end_main:
	ULNK
L__main_end_loop:
	BRA	L__main_end_loop
; end of _main
